# -*- coding: utf-8 -*-

# Copyright (C) 2010-2011 by Mike Gabriel <mike.gabriel@das-netzwerkteam.de>
# Copyright (C) 2010-2011 by Dick Kniep <dick.kniep@lindix.nl>
#
# PyHoca GUI is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 3 of the License, or
# (at your option) any later version.
#
# PyHoca GUI is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the
# Free Software Foundation, Inc.,
# 51 Franklin St, Fifth Floor, Boston, MA 02110-1301, USA.

try:
    import wxversion
    wxversion.select('2.9')
except: pass

try:
    import wxversion
    wxversion.select('2.8')
except: pass

import wx

class PyHocaGUI_Menu_TaskbarManageProfile(wx.Menu):
    """\
    STILL UNDOCUMENTED

    """
    def __init__(self, _PyHocaGUI, caller=None, profile_name=None):
        """\
        STILL UNDOCUMENTED

        """
        self._PyHocaGUI = _PyHocaGUI
        self._pyhoca_logger = self._PyHocaGUI._pyhoca_logger

        wx.Menu.__init__(self)

        ID_EDITPROFILE = wx.NewId()
        ID_DELETEPROFILE = wx.NewId()

        # preparing profile_name information for the main PyHocaGUI instance
        self._PyHocaGUI._eventid_profilenames_map[ID_EDITPROFILE] = \
            self._PyHocaGUI._eventid_profilenames_map[ID_DELETEPROFILE] = profile_name

        self.Append(text=_(u"Edit Profile"), id=ID_EDITPROFILE)
        self.AppendSeparator()
        self.Append(text=_(u"Delete Profile"), id=ID_DELETEPROFILE)

        self._PyHocaGUI.Bind(wx.EVT_MENU, self._PyHocaGUI.OnProfileEdit, id=ID_EDITPROFILE)
        self._PyHocaGUI.Bind(wx.EVT_MENU, self._PyHocaGUI.OnProfileDelete, id=ID_DELETEPROFILE)


class PyHocaGUI_Menu_TaskbarOptionsManager(wx.Menu):
    """\
    STILL UNDOCUMENTED

    """
    def __init__(self, _PyHocaGUI, caller=None):
        """\
        STILL UNDOCUMENTED

        """
        self._PyHocaGUI = _PyHocaGUI
        self._pyhoca_logger = self._PyHocaGUI._pyhoca_logger

        wx.Menu.__init__(self)

        ID_ABOUT = wx.NewId()
        self.Append(id=ID_ABOUT, text=_(u"About %s (%s)...") % (self._PyHocaGUI.appname, self._PyHocaGUI.version))
        self._PyHocaGUI.Bind(wx.EVT_MENU, self._PyHocaGUI.OnAbout, id=ID_ABOUT)

        if not self._PyHocaGUI.restricted_trayicon:
            self.AppendSeparator()

            ID_PROFILEMANAGER = wx.NewId()
            _maintain_profiles_item = self.AppendMenu(id=ID_PROFILEMANAGER, 
                                                      text=_(u"Profile Manager"), 
                                                      submenu=PyHocaGUI_Menu_TaskbarProfileNames(self._PyHocaGUI,
                                                                                                 caller=self,
                                                                                                 filter_profiles=[],
                                                                                                 disabled_profiles=self._PyHocaGUI.client_connected_profiles(return_profile_names=True),
                                                                                                 submenu=PyHocaGUI_Menu_TaskbarManageProfile,
                                                                                                 group_menus=False,
                                                                                                )
                                                     )
            if self._PyHocaGUI.profilemanager_disabled:
                _maintain_profiles_item.Enable(False)

            self.AppendSeparator()

            ID_PRINTINGPREFS = wx.NewId()
            _printingprefs_item = self.Append(id=ID_PRINTINGPREFS, text=_(u"Printing Preferences"))
            self._PyHocaGUI.Bind(wx.EVT_MENU, self._PyHocaGUI.OnPrintingPreferences, id=ID_PRINTINGPREFS)
            if self._PyHocaGUI.printingprefs_disabled:
                _printingprefs_item.Enable(False)

            ID_OPTIONS = wx.NewId()
            _options_item = self.Append(id=ID_OPTIONS, text=_(u"Client Options"))
            self._PyHocaGUI.Bind(wx.EVT_MENU, self._PyHocaGUI.OnOptions, id=ID_OPTIONS)
            if self._PyHocaGUI.options_disabled:
                _options_item.Enable(False)

            self.AppendSeparator()

        ID_EXIT = wx.NewId()
        self.Append(id=ID_EXIT, text=_("E&xit"))
        self._PyHocaGUI.Bind(wx.EVT_MENU, self._PyHocaGUI.OnTaskbarExit, id=ID_EXIT)


class PyHocaGUI_Menu_TaskbarSessionActions(wx.Menu):
    """\
    STILL UNDOCUMENTED

    """
    def __init__(self, _PyHocaGUI, caller=None, profile_name=None, session_name=None, status=None):
        """\
        STILL UNDOCUMENTED

        """
        self._PyHocaGUI = _PyHocaGUI
        self._pyhoca_logger = self._PyHocaGUI._pyhoca_logger

        wx.Menu.__init__(self)

        ID_TRANSFERSESSION = wx.NewId()
        ID_TRANSFERSESSION_DISABLED = wx.NewId()
        ID_RESUMESESSION = wx.NewId()
        ID_RESUMESESSION_DISABLED = wx.NewId()
        ID_SUSPENDSESSION = wx.NewId()
        ID_TERMINATESESSION = wx.NewId()

        # preparing profile_name information for the main PyHocaGUI instance
        self._PyHocaGUI._eventid_profilenames_map[ID_TRANSFERSESSION] = \
            self._PyHocaGUI._eventid_profilenames_map[ID_RESUMESESSION] = \
            self._PyHocaGUI._eventid_profilenames_map[ID_SUSPENDSESSION] = \
            self._PyHocaGUI._eventid_profilenames_map[ID_TERMINATESESSION] = profile_name

        # preparing session_name information for the main PyHocaGUI instance
        self._PyHocaGUI._eventid_sessionnames_map[ID_TRANSFERSESSION] = \
            self._PyHocaGUI._eventid_sessionnames_map[ID_RESUMESESSION] = \
            self._PyHocaGUI._eventid_sessionnames_map[ID_SUSPENDSESSION] = \
            self._PyHocaGUI._eventid_sessionnames_map[ID_TERMINATESESSION] = session_name

        _s = self._PyHocaGUI.get_session_of_session_name(session_name, return_object=True)

        if status == 'S':

            if _s is not None and _s.is_color_depth_ok():
                self.Append(text=_("Resume Session"), id=ID_RESUMESESSION)
            else:
                _rs = self.Append(text=_(u"Resume Session (not possible)"), id=ID_RESUMESESSION_DISABLED)
                _rs.Enable(False)

        elif status == 'R':

            if not session_name in self._PyHocaGUI.client_associated_sessions_of_profile_name(profile_name, return_session_names=True):

                if _s is not None and _s.is_color_depth_ok():
                    self.Append(text=_(u"Transfer Session"), id=ID_TRANSFERSESSION)
                else:
                    _ts = self.Append(text=_(u"Transfer Session (not possible)"), id=ID_TRANSFERSESSION_DISABLED)
                    _ts.Enable(False)

            self.Append(text=_(u"Suspend Session"), id=ID_SUSPENDSESSION)

        self.Append(text=_(u"Terminate Session"), id=ID_TERMINATESESSION)

        self._PyHocaGUI.Bind(wx.EVT_MENU, self._PyHocaGUI.OnSessionResume, id=ID_RESUMESESSION)
        self._PyHocaGUI.Bind(wx.EVT_MENU, self._PyHocaGUI.OnSessionResume, id=ID_TRANSFERSESSION)
        self._PyHocaGUI.Bind(wx.EVT_MENU, self._PyHocaGUI.OnSessionSuspend, id=ID_SUSPENDSESSION)
        self._PyHocaGUI.Bind(wx.EVT_MENU, self._PyHocaGUI.OnSessionTerminate, id=ID_TERMINATESESSION)


class PyHocaGUI_Menu_TaskbarProfileSharedFolders(wx.Menu):
    """\
    STILL UNDOCUMENTED

    """
    def __init__(self, _PyHocaGUI, caller=None, profile_name=None):
        """\
        STILL UNDOCUMENTED

        """
        self._PyHocaGUI = _PyHocaGUI
        self._pyhoca_logger = self._PyHocaGUI._pyhoca_logger

        wx.Menu.__init__(self)

        ID_SHARECUSTOMLOCALFOLDER = wx.NewId()
        ID_UNSHAREALLLOCALFOLDERS = wx.NewId()

        # preparing profile_name information for the main PyHocaGUI instance
        self._PyHocaGUI._eventid_profilenames_map[ID_SHARECUSTOMLOCALFOLDER] = \
            self._PyHocaGUI._eventid_profilenames_map[ID_UNSHAREALLLOCALFOLDERS] = profile_name

        _share_folder = self.Append(id=ID_SHARECUSTOMLOCALFOLDER, text=_(u"&Share custom local folder"))

        self.AppendSeparator()

        # FIXME: move this into python-x2go

        _profile_config = self._PyHocaGUI.get_profile_config(profile_name)
        _exported_folders = _profile_config['export'].replace(',', ';')
        _exported_folders = _exported_folders.strip().strip('"').strip().strip(';').strip()
        _exported_folders_list = _exported_folders.split(';')

        _sharable_folders = []
        _shared_folders = self._PyHocaGUI._X2goClient__profile_get_shared_folders(profile_name=profile_name) or []

        for _folder in _exported_folders_list:
            if ':' not in _folder: _folder = '%s:1' % _folder
            _folder_path = _folder.split(':')[0]
            _sharable_folders.append(_folder_path)

        self._PyHocaGUI._eventid_unshared_folders_map={}
        _unshared_folders = [ f for f in _sharable_folders if f and f not in _shared_folders ]

        if _unshared_folders:
            self.Append(id=wx.NewId(), text=_(u'Share:'))
            for _unshared_folder in _unshared_folders:
                ID_THISFOLDER = wx.NewId()
                _unshared_folder_item = self.Append(id=ID_THISFOLDER, text="      %s" % _unshared_folder)
                self._PyHocaGUI._eventid_profilenames_map[ID_THISFOLDER] = profile_name
                self._PyHocaGUI._eventid_unshared_folders_map[ID_THISFOLDER] = _unshared_folder
                self._PyHocaGUI.Bind(wx.EVT_MENU, self._PyHocaGUI.OnShareLocalFolder, id=ID_THISFOLDER)

            self.AppendSeparator()

        if _shared_folders:
            self.Append(id=wx.NewId(), text=_(u'Unshare:'))
            for _shared_folder in _shared_folders:
                ID_THISFOLDER = wx.NewId()
                _shared_folder_item = self.Append(id=ID_THISFOLDER, text="      %s" % _shared_folder)
                self._PyHocaGUI._eventid_profilenames_map[ID_THISFOLDER] = profile_name
                self._PyHocaGUI._eventid_shared_folders_map[ID_THISFOLDER] = _shared_folder
                self._PyHocaGUI.Bind(wx.EVT_MENU, self._PyHocaGUI.OnUnshareLocalFolder, id=ID_THISFOLDER)

            self.AppendSeparator()

        _unshare_folders = self.Append(id=ID_UNSHAREALLLOCALFOLDERS, text=_(u"Unshare &all local folders"))
        if not _shared_folders:
            _unshare_folders.Enable(False)

        self._PyHocaGUI.Bind(wx.EVT_MENU, self._PyHocaGUI.OnShareCustomLocalFolder, id=ID_SHARECUSTOMLOCALFOLDER)
        self._PyHocaGUI.Bind(wx.EVT_MENU, self._PyHocaGUI.OnUnshareAllLocalFolders, id=ID_UNSHAREALLLOCALFOLDERS)


class PyHocaGUI_Menu_TaskbarSessionProfile(wx.Menu):
    """\
    STILL UNDOCUMENTED

    """
    def __init__(self, _PyHocaGUI, caller=None, profile_name=None):
        """\
        STILL UNDOCUMENTED

        """
        self._PyHocaGUI = _PyHocaGUI
        self._pyhoca_logger = self._PyHocaGUI._pyhoca_logger

        wx.Menu.__init__(self)

        ID_SESSIONSTART=wx.NewId()
        ID_CLEANSESSIONS = wx.NewId()
        ID_EDITPROFILEWHILECONNECTED = wx.NewId()
        ID_SHARELOCALFOLDER = wx.NewId()
        ID_UNSHAREFOLDERS = wx.NewId()
        ID_DISCONNECT = wx.NewId()

        current_profile_config = self._PyHocaGUI.get_profile_config(profile_name)

        # preparing profile_name information for the main PyHocaGUI instance
        self._PyHocaGUI._eventid_profilenames_map[ID_SESSIONSTART] = \
            self._PyHocaGUI._eventid_profilenames_map[ID_CLEANSESSIONS] = \
            self._PyHocaGUI._eventid_profilenames_map[ID_EDITPROFILEWHILECONNECTED] = \
            self._PyHocaGUI._eventid_profilenames_map[ID_SHARELOCALFOLDER] = \
            self._PyHocaGUI._eventid_profilenames_map[ID_UNSHAREFOLDERS] = \
            self._PyHocaGUI._eventid_profilenames_map[ID_DISCONNECT] = profile_name

        self.Append(id=ID_SESSIONSTART, text=_(u"Start &new Session"))
        self.AppendSeparator()

        _query_session_uuid = self._PyHocaGUI.client_connected_sessions_of_profile_name(profile_name, return_objects=False)[0]
        _session_list = self._PyHocaGUI.list_sessions(_query_session_uuid)

        if _session_list:

            # newest sessions at the top
            _session_list_names = _session_list.keys()
            _session_list_names.reverse()
            for session_name in _session_list_names:

                _s_id = wx.NewId()

                if _session_list[session_name].status == 'R':
                    state = _(u'Running')
                elif _session_list[session_name].status == 'S':
                    state = _(u'Suspended')
                session_submenu = self.AppendMenu(id=_s_id, text=u'%s: »%s«' % (state, session_name), 
                                                  submenu=PyHocaGUI_Menu_TaskbarSessionActions(self._PyHocaGUI, caller=self,
                                                                                               profile_name=profile_name,
                                                                                               session_name=session_name,
                                                                                               status=_session_list[session_name].status,
                                                                                              )
                                                 )
                if self._PyHocaGUI._temp_disabled_session_names.has_key(profile_name) and session_name in self._PyHocaGUI._temp_disabled_session_names[profile_name]:
                    session_submenu.Enable(False)

            if _session_list.keys():
                self.Append(id=ID_CLEANSESSIONS, text=_(u"&Clean all sessions"))
                self.AppendSeparator()
        self.Append(id=ID_EDITPROFILEWHILECONNECTED, text=_(u"Customize &profile"))
        if current_profile_config['useexports'] and self._PyHocaGUI._X2goClient__profile_is_folder_sharing_available(profile_name=profile_name):

            _shared_folders = self.AppendMenu(id=ID_SHARELOCALFOLDER, text=_(u"Shared &folders"),
                                            submenu=PyHocaGUI_Menu_TaskbarProfileSharedFolders(self._PyHocaGUI, caller=self,
                                                                                        profile_name=profile_name)
                                           )
            if not self._PyHocaGUI._X2goClient__client_associated_sessions_of_profile_name(profile_name=profile_name, return_objects=False):
                _shared_folders.Enable(False)

        self.AppendSeparator()
        self.Append(id=ID_DISCONNECT, text=_(u"&Disconnect from Server"))

        self._PyHocaGUI.current_profile_name = profile_name
        self._PyHocaGUI.Bind(wx.EVT_MENU, self._PyHocaGUI.OnSessionStart, id=ID_SESSIONSTART)
        self._PyHocaGUI.Bind(wx.EVT_MENU, self._PyHocaGUI.OnCleanSessions, id=ID_CLEANSESSIONS)
        self._PyHocaGUI.Bind(wx.EVT_MENU, self._PyHocaGUI.OnProfileEditWhileConnected, id=ID_EDITPROFILEWHILECONNECTED)
        self._PyHocaGUI.Bind(wx.EVT_MENU, self._PyHocaGUI.OnServerDisconnect, id=ID_DISCONNECT)


class PyHocaGUI_Menu_TaskbarProfileNames(wx.Menu):
    """\
    STILL UNDOCUMENTED

    """
    def __init__(self, _PyHocaGUI, caller=None, group_name='', sub_profile_items=[], filter_profiles=[], disabled_profiles=[], bind_method=None, submenu=None, group_menus=True):
        """\
        STILL UNDOCUMENTED

        """
        self._PyHocaGUI = _PyHocaGUI
        self._pyhoca_logger = self._PyHocaGUI._pyhoca_logger

        wx.Menu.__init__(self)

        if type(caller) == PyHocaGUI_Menu_TaskbarOptionsManager:
            ID_ADDPROFILE = wx.NewId()
            self.Append(id=ID_ADDPROFILE, text=_(u"Add Profile"))
            self._PyHocaGUI.Bind(wx.EVT_MENU, self._PyHocaGUI.OnProfileAdd, id=ID_ADDPROFILE)

            self.AppendSeparator()

        if sub_profile_items:
            _profile_names = sub_profile_items
        else:
            _profile_names = self._PyHocaGUI.session_profiles.profile_names
        _profile_names.sort()

        _profile_groups = []
        if group_menus:

            # grouping of session profile menus
            for profile_name in _profile_names:
                if len(profile_name.split('/')) >= 2:
                    _group_name = profile_name.split('/')[0]
                    if not _group_name in _profile_groups: 
                        _profile_groups.append(_group_name)

            _profile_groups.sort()

            for profile_group in _profile_groups:
                _sub_profile_items = []
                for profile_name in [ p for p in _profile_names if p.startswith('%s/' % profile_group) ]:
                    _sub_profile_name = "/".join(profile_name.split('/')[1:])
                    _sub_profile_items.append(_sub_profile_name)
                    filter_profiles.append(profile_name)

                _this_id = wx.NewId()
                _group = self.AppendMenu(text=profile_group, id=_this_id,
                                         submenu=PyHocaGUI_Menu_TaskbarProfileNames(self._PyHocaGUI, 
                                                                                    caller=self,
                                                                                    sub_profile_items=_sub_profile_items,
                                                                                    filter_profiles=[],
                                                                                    disabled_profiles=disabled_profiles,
                                                                                    bind_method=bind_method,
                                                                                    group_name=profile_group,
                                                                                    group_menus=False)
                                        )

        if filter_profiles:
            _profile_names = [ p for p in _profile_names if p not in filter_profiles ]

        for profile_name in _profile_names:
            if group_name:
                _real_profile_name = '%s/%s' % (group_name, profile_name)
                _show_profile_name = profile_name
            else:
                _real_profile_name = profile_name
                _show_profile_name = profile_name
            _this_id = wx.NewId()
            self._PyHocaGUI._eventid_profilenames_map[_this_id] = _real_profile_name
            _menu_profile_name = self._PyHocaGUI.show_profile_metatypes and '%s (%s)' % (_show_profile_name, self._PyHocaGUI.get_profile_metatype(_real_profile_name)) or _show_profile_name
            if submenu is not None:
                _sub = self.AppendMenu(text=_menu_profile_name, id=_this_id, submenu=submenu(self._PyHocaGUI, caller=self, profile_name=_show_profile_name))
                if disabled_profiles and _real_profile_name in disabled_profiles:
                    _sub.Enable(False)
            else:
                _item = self.Append(text=_menu_profile_name, id=_this_id)

                if disabled_profiles and _real_profile_name in disabled_profiles:
                    _item.Enable(False)
                if bind_method is not None:
                    self._PyHocaGUI.Bind(wx.EVT_MENU, bind_method, id=_this_id)
                    self._PyHocaGUI.Bind(wx.EVT_UPDATE_UI, self.OnUpdateUI, id=_this_id)

        if not group_name and (not _profile_groups and not _profile_names) and not filter_profiles:
            _dummy = self.Append(text=_(u'No session profiles defined'), id=wx.NewId())
            _dummy.Enable(False)

    def OnUpdateUI(self, evt):
        profile_name = self._PyHocaGUI._eventid_profilenames_map[evt.GetId()]
        if profile_name in self._PyHocaGUI._temp_disabled_profile_names:
            self._pyhoca_logger('Updating UI, temporarily disabling session profile %s' % profile_name)
            self.Enable(id=evt.GetId(), enable=False)
        elif profile_name not in self._PyHocaGUI._temp_disabled_profile_names and profile_name not in self._PyHocaGUI.client_connected_sessions(return_profile_names=True):
            self._pyhoca_logger('Updating UI, re-enabling session profile %s' % profile_name)
            self.Enable(id=evt.GetId(), enable=True)


class PyHocaGUI_Menu_TaskbarSessionManager(wx.Menu):
    """\
    STILL UNDOCUMENTED

    """
    def __init__(self, _PyHocaGUI, caller=None):
        """\
        STILL UNDOCUMENTED

        """
        self._PyHocaGUI = _PyHocaGUI
        self._pyhoca_logger = self._PyHocaGUI._pyhoca_logger

        wx.Menu.__init__(self)

        ID_AUTHENTICATE = wx.NewId()
        ID_EXIT = wx.NewId()

        _auth_menu_text = self._PyHocaGUI.start_on_connect and _(u'Start/Resume Session') or _(u'Connect Server')
        self.AppendMenu(id=ID_AUTHENTICATE, 
                        text=_auth_menu_text, 
                        submenu=PyHocaGUI_Menu_TaskbarProfileNames(self._PyHocaGUI, 
                                                                   caller=self,
                                                                   filter_profiles=[],
                                                                   disabled_profiles=self._PyHocaGUI.client_connected_sessions(return_profile_names=True),
                                                                   bind_method=self._PyHocaGUI.OnSessionAuthenticate))
        self.AppendSeparator()

        _profile_names = self._PyHocaGUI.session_profiles.profile_names
        _profile_names.sort()

        _connected_sessions = False
        for profile_name in _profile_names:
            if profile_name in self._PyHocaGUI._X2goClient__client_connected_sessions(return_profile_names=True):
                _connected_sessions = True
                _this_id = wx.NewId()

                _menu_profile_name = self._PyHocaGUI.show_profile_metatypes and '%s (%s)' % (profile_name, self._PyHocaGUI.get_profile_metatype(profile_name)) or profile_name
                self.AppendMenu(text=_menu_profile_name, 
                                id=_this_id, 
                                submenu=PyHocaGUI_Menu_TaskbarSessionProfile(self._PyHocaGUI, caller=self, profile_name=profile_name))

        if _connected_sessions:
            self.AppendSeparator()

        self.Append(id=ID_EXIT, text=_(u"E&xit"))
        self._PyHocaGUI.Bind(wx.EVT_MENU, self._PyHocaGUI.OnTaskbarExit, id=ID_EXIT)


