# -*- coding: utf-8 -*-

# Copyright (C) 2010-2011 by Mike Gabriel <mike.gabriel@das-netzwerkteam.de>
# Copyright (C) 2010-2011 by Dick Kniep <dick.kniep@lindix.nl>
#
# PyHoca GUI is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 3 of the License, or
# (at your option) any later version.
#
# PyHoca GUI is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the
# Free Software Foundation, Inc.,
# 51 Franklin St, Fifth Floor, Boston, MA 02110-1301, USA.

modules ={}

try:
    import wxversion
    wxversion.select('2.9')
except: pass

try:
    import wxversion
    wxversion.select('2.8')
except: pass

# Python X2go
import x2go

import gevent
import gevent.monkey
gevent.monkey.patch_all()

import wx

if x2go.X2GOCLIENT_OS == 'Windows':
    import win32gui

import os
import sys
import copy

# PyHoca-GUI modules
import menus_taskbar
import profilemanager
import basepath

_icons_location = basepath.icons_basepath


class PyHocaGUI_TaskBarIcon(wx.TaskBarIcon):
    """\
    STILL UNDOCUMENTED

    """
    def __init__(self, _about):
        """\
        STILL UNDOCUMENTED

        """
        wx.TaskBarIcon.__init__(self)
        self._PyHocaGUI = _about._PyHocaGUI
        self._pyhoca_logger = self._PyHocaGUI._pyhoca_logger
        self._pyhoca_logger('start TaskBarIcon of type: %s' % (wx.PlatformInfo, ), loglevel=x2go.loglevel_INFO)
        self.SetIconIdle()
        self.imgidx = 1
        self.tooltip = ""

    def SetIconConnecting(self, profile_name):
        self.icon = self.MakeIcon(icon_name='pyhoca-trayicon')
        if x2go.X2GOCLIENT_OS == 'Windows':
            self.icon = self.MakeIcon(icon_name='x2go-logo-ubuntu')
            self.SetIcon(self.icon, _(u"PyHoca-GUI\nConnecting you to ,,%s\'\'") % profile_name)
        else:
            self.icon = self.MakeIcon(icon_name='pyhoca-trayicon')
            self.SetIcon(self.icon, _(u"PyHoca-GUI (Python X2goClient)\nCurrently connecting you to remote X2go server ,,%s\'\'") % profile_name)

    def SetIconIdle(self):
        if x2go.X2GOCLIENT_OS == 'Windows':
            self.icon = self.MakeIcon(icon_name='x2go-logo-ubuntu')
            self.SetIcon(self.icon, _(u"PyHoca-GUI\nConnecting you to X2go..."))
        else:
            self.icon = self.MakeIcon(icon_name='pyhoca-trayicon')
            self.SetIcon(self.icon, _(u"PyHoca-GUI (Python X2goClient)\nClient for connecting you to a remote X2go server"))

    def CreateSessionManagerPopupMenu(self, evt):
        """\
        STILL UNDOCUMENTED

        """
        self.menu_sessionmanager = self.PopupMenu(menus_taskbar.PyHocaGUI_Menu_TaskbarSessionManager(self._PyHocaGUI, caller=self,))
        return self.menu_sessionmanager

    def CreatePopupMenu(self):
        """\
        This method is called by the base class when it needs to popup
        the menu for the default EVT_RIGHT_DOWN event.  Just create
        the menu how you want it and return it from this function,
        the base class takes care of the rest.
        """
        return self.CreateProfileManagerPopupMenu()

    def CreateProfileManagerPopupMenu(self):
        self.menu_optionsmanager = self.PopupMenu(menus_taskbar.PyHocaGUI_Menu_TaskbarOptionsManager(self._PyHocaGUI, caller=self,))
        return self.menu_optionsmanager

    def MakeIcon(self, icon_name):
        """\
        The various platforms have different requirements for the
        icon size...
        """
        if "wxMSW" in wx.PlatformInfo:
            img = wx.Image('%s/PyHoca/16x16/%s.png' % (_icons_location, icon_name))
        elif "wxGTK" in wx.PlatformInfo:
            img = wx.Image('%s/PyHoca/22x22/%s.png' % (_icons_location, icon_name))
        elif "wxMAC" in wx.PlatformInfo:
            img = wx.Image('%s/PyHoca/128x128/%s.png' % (_icons_location, icon_name))
        icon = wx.IconFromBitmap(img.ConvertToBitmap())
        return icon

    def Close(self):
        self.RemoveIcon()

